import { ActionFormData, FormResponse } from "@minecraft/server-ui"
import * as server from "@minecraft/server"
import {world} from "@minecraft/server"


server.system.afterEvents.scriptEventReceive.subscribe(result => {
    if (result.id == "simple_vehicles:FirstTime" && !result.sourceEntity.hasTag("simvehicles")) {
        FirstJoinPlayer(result.sourceEntity)
    }
})
/**
*@param {server.Entity} player
*/
function FirstJoinPlayer(player) {
    const FirstJoinPlayer = new ActionFormData()
        .title("Simple Vehicles Addon 3.6.0 - The Functions Update")
        .body({ "rawtext": [{ "translate": "SimVeh.welcometext.0" }] })
        .button("Close", "textures/items/barrier")

    FirstJoinPlayer.show(player).then(response => {
        if (response.canceled) return;
        switch (response.selection) {
            case 0:
                break;
        }
    })
};




////FormsSEction
const form = new ActionFormData();
form.title("Simple Vehicles Addon")
form.body({"rawtext": [{"translate": "SimpleVehiclesAddon.Info"}]})
form.button("Changelog", "textures/items/apple")
form.button("Vehicles", "textures/items/car")
form.button("Support and Donate", "textures/support")
form.button("Credits", "textures/ui/blue_info_glyph")
form.button("Exit", "textures/exit");

const Simple_Vehicles = new ActionFormData();
Simple_Vehicles.title("Simple Vehicles Addon")
Simple_Vehicles.body({"rawtext": [{"translate": "SimpleVehiclesAddon.Info"}]})
Simple_Vehicles.button("Changelog", "textures/blocks/acacia_trapdoor")
Simple_Vehicles.button("Vehicles", "textures/blocks/barrier")
Simple_Vehicles.button("Support and Donate", "textures/items/apple")
Simple_Vehicles.button("Credits", "textures/ui/blue_info_glyph")
Simple_Vehicles.button("Exit", "textures/exit");


world.afterEvents.itemUse.subscribe((event) => {
    const { source, itemStack } = event;
    if (itemStack.typeId === "simple_vehicles:infopaper") {
        form.show(source).then((response) => {
            if (response.canceled) return;
            handleFormResponse(source, response.selection);
        });
    }
    if (itemStack.typeId === "simple_vehicles:infopapercrafting") {
        Simple_Vehicles.show(source).then((response) => {
            if (response.canceled) return;
            handleFormResponse(source, response.selection);
        });
    }
});













/////Functions Where does it work
function handleFormResponse(player, selection) {
    switch (selection) {
        case 0:
            showChangelog(player)
            break;
        case 1:
            showVehicles(player)
            break;
        case 2:
            showSupportAndDonate(player)
            break;
        case 3:
            CreditsZone(player)
            break;
        case 4:
            break;
        
    }
}

function showChangelog(player) {
    const changelogForm = new ActionFormData();
    changelogForm.title("Changelogs")
    changelogForm.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.ChangelogTitle" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody" }, { "text": "\n" },  { "translate": "SimpleVehiclesAddon.ChangelogBody2" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody3" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody4" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody14" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody5" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody6" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody7" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody8" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody9" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody10" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody11" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody12" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody13" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody15" } , { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody16" } , { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody17" } , { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody18" } , { "text": "\n" }, { "translate": "SimpleVehiclesAddon.ChangelogBody19" }  ] })
    changelogForm.button("Exit", "textures/exit");
    changelogForm.show(player).then((response) => {
        if (response.canceled) {
            form.show(player);
        }
    });
}
function showSupportAndDonate(player) {
    const SupportAndDonateForm = new ActionFormData();
    SupportAndDonateForm.title("Support And Donate")
    SupportAndDonateForm.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.SupportAndDonate0" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.SupportAndDonate1" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.SupportAndDonate2" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.SupportAndDonate3" }, { "text": "\n" },]})
    SupportAndDonateForm.button("Exit", "textures/exit");
    SupportAndDonateForm.show(player).then((response) => {
        if (response.canceled) {
            form.show();
        }
    });
}

function CreditsZone(player) {
    const CreditsForm = new ActionFormData();
    CreditsForm.title("Credits")
    CreditsForm.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.CreditsZone0" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone1" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone2" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone3" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone4" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone5" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.CreditsZone6" }, { "text": "\n" }, { "text": "\n" } ]})
    CreditsForm.button("Exit", "textures/exit");
    CreditsForm.show(player).then((response) => {
        if (response.canceled) {
            form.show();
        }
    });
}

////Show Vehicles Section
////Show Vehicles Section
////Show Vehicles Section
////Show Vehicles Section
////Show Vehicles Section
////Show Vehicles Section
////Show Vehicles Section
function showVehicles(player) {
    const vehiclesForm = new ActionFormData();
    vehiclesForm.title("SimpleVehiclesAddon.vehicleform")
    vehiclesForm.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.ChangelogTitle" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.VehiclesBody" }]})
    vehiclesForm.button("AE86", "textures/items/car")
    vehiclesForm.button("Ambulance", "textures/items/car")
    vehiclesForm.button("Exit", "textures/exit");
    vehiclesForm.show(player).then((response) => {
        if (response.canceled) return;
            handleVehiclesFormResponse(player, response.selection);
        }
    )
}
function handleVehiclesFormResponse(player, selection) {
    switch (selection) {
        case 0:
            showAE86(player)
            break;
        case 1:
            showAmbulance(player)
            break;
        case 2:
            break;
        
    }
}
function showAE86(player) {
    const AE86Form = new ActionFormData();
    AE86Form.title("SimpleVehiclesAddon")
    AE86Form.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.AE86" }, { "text": "\n" }, { "text": "\n" }, { "translate": "SimpleVehiclesAddon.AE86.source" }]})
    AE86Form.button("Exit", "textures/exit");
    AE86Form.show(player).then((response) => {
        if (response.canceled) {
            vehiclesForm.show();
        }
    });
}
function showAmbulance(player) {
    const AmnulanceForm = new ActionFormData();
    AmnulanceForm.title("SimpleVehiclesAddon")
    AmnulanceForm.body({ "rawtext": [{ "translate": "SimpleVehiclesAddon.Ambulance" }, { "text": "\n" }, { "text": "\n" }]})
    AmnulanceForm.button("Exit", "textures/exit");
    AmnulanceForm.show(player).then((response) => {
        if (response.canceled) {
            vehiclesForm.show();
        }
    });
}
