import { world, system } from "@minecraft/server";

const setActionBar = (player, ridingEntity, velocity) => {
  if (!player || !ridingEntity) return;
  player.onScreenDisplay.setActionBar(
    `        §kron§rSpeedometer§kron§r\nVehicle Name: ${ridingEntity.typeId}\n   Fuel: \n  Speed: ${velocity.toFixed(1)} KM/h`
  );
};

const setActionBar2 = (player, ridingEntity, velocity) => {
  if (!player || !ridingEntity) return;
  player.onScreenDisplay.setActionBar(
    ` §kron§rSpeedometer§kron§r\nVehicle Name: ${ridingEntity.typeId}\n   Fuel: \n  Speed: ${velocity.toFixed(1)} KM/h`
  );
};

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    const ride = player.getComponent("minecraft:riding");
    if (!ride || !ride.entityRidingOn) continue;
    const ridingEntity = ride.entityRidingOn;
    if (!ridingEntity.typeId.startsWith("simple_vehicles")) continue;
    const velocity = (Math.sqrt(Math.pow(player.getVelocity().x, 2) + Math.pow(player.getVelocity().y, 2) + Math.pow(player.getVelocity().z, 2)) * 20) * 3.6;
    setActionBar(player, ridingEntity, velocity);
    if (!ridingEntity.typeId === "simple_vehicles:bike") {
      setActionBar2(player, ridingEntity, velocity);
    }
  }
}, 1);