
import { world, system } from "@minecraft/server";

const setActionBar = (player, ridingEntity, velocity, titleDecoration) => {
  if (!player ||!ridingEntity) return;
  player.onScreenDisplay.setActionBar(
    `${titleDecoration} §kron§rSpeedometer§kron§r${titleDecoration}\nVehicle Name: ${ridingEntity.typeId}\n  Speed: ${velocity.toFixed(1)} KM/h`
  );
};

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    const ride = player.getComponent("minecraft:riding");
    const ridingEntity = ride?.entityRidingOn;
    const velocity = (Math.sqrt(Math.pow(player.getVelocity().x, 2) + Math.pow(player.getVelocity().y, 2) + Math.pow(player.getVelocity().z, 2)) * 20) * 3.6;
    
    /*if (ridingEntity &&!ridingEntity.typeId.startsWith("minecraft") && !ridingEntity.typeId.startsWith("ashminggu") && !ridingEntity.typeId.startsWith("stulker") && !ridingEntity.typeId.startsWith("shapescape") && !ridingEntity.typeId.startsWith("spicymiatta") && !ridingEntity.typeId.startsWith("honeyfrost") && !ridingEntity.typeId.startsWith("hf") && !ridingEntity.typeId.startsWith("kubo") && !ridingEntity.typeId.startsWith("hdp") && !ridingEntity.typeId.startsWith("custom") && !ridingEntity.typeId.startsWith("cc") && !ridingEntity.typeId.startsWith("mwa") && !ridingEntity.typeId.startsWith("valitxv") && !ridingEntity.typeId.startsWith("vf") && !ridingEntity.typeId.startsWith("jigarbov") && !ridingEntity.typeId.startsWith("jig") && !ridingEntity.typeId.startsWith("adn") && ridingEntity.typeId.startsWith("simple_vehicles")) {*/
    if (ridingEntity &&!["minecraft", "ashminggu", "stulker", "shapescape", "spicymiatta", "honeyfrost", "hf", "kubo", "hdp", "custom", "cc", "mwa", "valitxv", "vf", "jigarbov", "jig", "adn"].some(prefix => ridingEntity.typeId.startsWith(prefix)) && ridingEntity.typeId.startsWith("simple_vehicles")) {
      let titleDecoration = '';
      if (ridingEntity.typeId.startsWith("simple_vehicles:bike")) {
        titleDecoration = '';
      }
      setActionBar(player, ridingEntity, velocity, titleDecoration);
    }
  }
}, 1);



/*import { world, system, EntityQueryOptions } from "@minecraft/server";

// Function to add fuel to an entity based on the item used
function addFuelToEntity(entity, fuelAmount) {
    try {
        // Add the specified amount of oil to the entity
        entity.runCommand(`scoreboard players add @s oil ${fuelAmount}`);

        // Apply speed effect if oil level is above 1000
        entity.runCommand("effect @s[tag=car,scores={oil=1000..}] speed 20 24 true");
    } catch (error) {
        console.error(`Failed to add fuel or apply effect: ${error}`);
    }
}

// Function to reduce fuel over time
function reduceFuelOverTime() {
    try {
        // Get all entities with the tag 'car' and oil score > 0
        const queryOptions = new EntityQueryOptions();
        queryOptions.tags = ["car"];
        queryOptions.scoreOptions = {
            objective: "oil",
            minScore: 1
        };

        const entities = world.getEntities(queryOptions);

        entities.forEach(entity => {
            // Reduce oil by 1
            entity.runCommand("scoreboard players remove @s oil 1");

            // Remove speed effect if oil is 0 or less
            entity.runCommand("execute if score @s oil matches ..0 run effect @s clear speed");
        });
    } catch (error) {
        console.error(`Failed to reduce fuel: ${error}`);
    }
}

// Function to initialize the fuel system
function initializeFuelSystem() {
    // Listen for item use events
    world.events.beforeItemUse.subscribe(eventData => {
        const player = eventData.source;
        const item = eventData.item;

        let fuelAmount = 0;

        // Determine the fuel amount based on the item used
        if (item.id === "simple_vehicles:jerry_can") {
            fuelAmount = 100;
        } else if (item.id === "simple_vehicles:fuel_bottle") {
            fuelAmount = 50;
        } else if (item.id === "simple_vehicles:gas_nozzle") {
            fuelAmount = 1000;
        }

        if (fuelAmount > 0) {
            // Get the target entities (use specific entity types)
            const entityTypes = ["simple_vehicles:car", "simple_vehicles:bus", "simple_vehicles:jeep"];
            
            entityTypes.forEach(entityType => {
                const queryOptions = new EntityQueryOptions();
                queryOptions.type = entityType;

                const entities = world.getEntities(queryOptions);

                entities.forEach(entity => {
                    addFuelToEntity(entity, fuelAmount);
                });
            });
        }
    });

    // Reduce fuel over time (every second)
    system.runInterval(reduceFuelOverTime, 20); // 20 ticks = 1 second
}

// Initialize the fuel system
initializeFuelSystem();

const setActionBar = (player, ridingEntity, velocity, titleDecoration) => {
    if (!player || !ridingEntity) return;

    // Get the fuel level of the riding entity
    let fuelLevel = 0;
    try {
        const result = ridingEntity.runCommand(`scoreboard players get @s oil`);
        fuelLevel = parseInt(result.statusMessage.split(" ")[1]);
    } catch (error) {
        console.error(`Failed to get fuel level: ${error}`);
    }

    player.onScreenDisplay.setActionBar(
        `${titleDecoration} §kron§rSpeedometer§kron§r${titleDecoration}\nVehicle Name: ${ridingEntity.typeId}\nFuel: ${fuelLevel}\nSpeed: ${velocity.toFixed(1)} KM/h`
    );
};

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const ride = player.getComponent("minecraft:riding");
        const ridingEntity = ride?.entityRidingOn;
        const velocity = (Math.sqrt(Math.pow(player.getVelocity().x, 2) + Math.pow(player.getVelocity().y, 2) + Math.pow(player.getVelocity().z, 2)) * 20) * 3.6;

        if (ridingEntity && !ridingEntity.typeId.startsWith("minecraft") && ridingEntity.typeId.startsWith("simple_vehicles")) {
            let titleDecoration = '';
            if (ridingEntity.typeId.startsWith("simple_vehicles:bike")) {
                titleDecoration = '';
            }
            setActionBar(player, ridingEntity, velocity, titleDecoration);
        }
    }
}, 1);*/