import { world, system } from "@minecraft/server";
/**
 * Hides or resets the horse health HUD based on whether the player is riding a simple vehicle or not.
 */
function cameraHud() {
  world.getAllPlayers().forEach((player) => {
    const riding = player.getComponent('minecraft:riding')?.entityRidingOn;
    const command = riding && riding.typeId.startsWith('simple_vehicles')
      ? `hud @s hide horse_health`
      : `hud @s reset horse_health`;

    player.runCommandAsync(command);
  });
}
// Run the `cameraHud` function every 1 game tick (approximately 20 times per second)
system.runInterval(() => {
  cameraHud();
}, 1);